## ros-melodic-dbw-fca-can 1.0.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(dbw_fca_can)

find_package(catkin REQUIRED COMPONENTS
  rospy
  roscpp
  nodelet
  std_msgs
  geometry_msgs
  sensor_msgs
  can_msgs
  dataspeed_can_msg_filters
  dbw_fca_msgs
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "Enabling coverage testing")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
endif()

if (NOT "${CMAKE_CXX_STANDARD_COMPUTED_DEFAULT}")
  message(STATUS "Changing CXX_STANDARD from C++98 to C++11")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif ("${CMAKE_CXX_STANDARD_COMPUTED_DEFAULT}" STREQUAL "98")
  message(STATUS "Changing CXX_STANDARD from C++98 to C++11")
  set(CMAKE_CXX_STANDARD 11)
endif()

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME}
  src/nodelet.cpp
  src/DbwNode.cpp
)
add_dependencies(${PROJECT_NAME} ${catkin_EXPORTED_TARGETS})
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

add_executable(${PROJECT_NAME}_dbw_node
  src/node.cpp
)
add_dependencies(${PROJECT_NAME}_dbw_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(${PROJECT_NAME}_dbw_node
  ${PROJECT_NAME}
)
set_target_properties(${PROJECT_NAME}_dbw_node PROPERTIES OUTPUT_NAME dbw_node PREFIX "")

install(TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_dbw_node
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)
install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(DIRECTORY scripts
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        USE_SOURCE_PERMISSIONS
)
install(FILES nodelets.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(DIRECTORY launch
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if (CATKIN_ENABLE_TESTING)
  add_subdirectory(tests)
endif()

=== debian/changelog ===
ros-melodic-dbw-fca-can (1.0.10-1stretch) stretch; urgency=high

  * Add gear reject enumerations
  * Increase CMake minimum version to 3.0.2 to avoid warning about CMP0048
    http://wiki.ros.org/noetic/Migration#Increase_required_CMake_version_to_avoid_author_warning
  * Remove unused parameter from launch file
  * Add sensor reports for wiper, highbeam, and hazard light
  * Add sensor reports for gyro, accelerometer, GPS, and tire pressure
  * Contributors: Kevin Hallenbeck, Sreedevi Adukkathayar, Sun Hwang

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 09 Jul 2020 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.9-1stretch) stretch; urgency=high

  * Update firmware versions
  * Report NAN for signals that are unavailable/faulted
  * Add door commands
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 14 Feb 2020 05:00:00 -0000

ros-melodic-dbw-fca-can (1.0.8-1stretch) stretch; urgency=high

  * Add launch file argument to switch between Jeep and Pacifica URDF models
  * Contributors: Micho Radovnikovich

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 17 Oct 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.7-1stretch) stretch; urgency=high

  * Added argument to enable/disable CAN message filtering on DBW message range
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 13 Sep 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.6-1stretch) stretch; urgency=high

  * Updated firmware versions
  * Updated website maintenance link
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 13 Aug 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.5-1stretch) stretch; urgency=high

  * Extend licensing to each module
  * Contributors: Kevin Hallenbeck, Sun Hwang

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 24 Jul 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.4-1stretch) stretch; urgency=high

  * Added support for non-hybrid brake report values
  * Added gear number to ThrottleInfoReport
  * Contributors: Kevin Hallenbeck, Sun Hwang

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 11 Jul 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.3-1stretch) stretch; urgency=high

  * Added warnings for unknown and unsupported command types
  * Added FORD_C1 platform
  * Added fuel level report message
  * Added casts to force single precision floating point math
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 03 May 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.2-1stretch) stretch; urgency=high



 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 14 Mar 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.1-1stretch) stretch; urgency=high

  * Updated firmware versions
  * Added support for firmware change that uses SVEL resolution of 4 deg/s
  * Refactored tcpNoDelay() for subscribers
  * Added missing tests for PlatformVersion.h
  * Contributors: Kevin Hallenbeck, Micho Radovnikovich

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 01 Mar 2019 05:00:00 -0000

ros-melodic-dbw-fca-can (1.0.0-1stretch) stretch; urgency=high

  * Updated firmware versions
  * Added BTYPE (brake type) bit
  * Added CMD_DECEL brake command type (only for non-hybrid platforms)
  * Added dataspeed_ulc_can to dbw.launch
  * Added throttlePercentFromPedal lookup table function and corresponding test
  * Use the ${catkin_EXPORTED_TARGETS} macro for target dependencies
  * Contributors: Kevin Hallenbeck, Micho Radovnikovich

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 30 Nov 2018 05:00:00 -0000

ros-melodic-dbw-fca-can (0.0.2-1stretch) stretch; urgency=high

  * Updated firmware versions
  * Added platform FCA_WK2 (Jeep Grand Cherokee)
  * Force forwarding of brake command type when ABS module is present (instead of BPEC module)
  * Disengage on any fault for brake/throttle/steering (change AND to OR)
  * Added cruise control buttons
  * Latch firmware version on any change (previously only latched once)
  * Changed pedal_luts default from true to false (forward command type by default now)
  * Disregard overrides on unused subsystems using the TIMEOUT bit
  * Removed cruise control related buttons that are not implemented by firmware at this time
  * Fixed typo in nodelets.xml of dbw_fca_can
  * Renamed steering CMD_TYPE and TMODE
  * Set CXX_STANDARD to C++11 only when necessary
  * Use sign of wheel speeds to set sign of vehicle speed
  * Removed unused dependencies and includes
  * Removed steering debug message
  * Handle version message with a map/database of several platform/module combinations (ported from dbw_mkz_can)
  * Contributors: Kevin Hallenbeck, Micho Radovnikovich

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 23 Oct 2018 04:00:00 -0000

ros-melodic-dbw-fca-can (0.0.1-1stretch) stretch; urgency=high

  * Initial release
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 08 Aug 2018 04:00:00 -0000

=== debian/control ===
Source: ros-melodic-dbw-fca-can
Section: misc
Priority: optional
Maintainer: Kevin Hallenbeck <khallenbeck@dataspeedinc.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-can-msgs, ros-melodic-catkin, ros-melodic-dataspeed-can-msg-filters, ros-melodic-dbw-fca-msgs, ros-melodic-geometry-msgs, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-roslaunch, ros-melodic-rospy, ros-melodic-sensor-msgs, ros-melodic-std-msgs
Homepage: http://dataspeedinc.com
Standards-Version: 3.9.2

Package: ros-melodic-dbw-fca-can
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-can-msgs, ros-melodic-dataspeed-can-usb, ros-melodic-dataspeed-ulc-can, ros-melodic-dbw-fca-description, ros-melodic-dbw-fca-msgs, ros-melodic-geometry-msgs, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-roslaunch, ros-melodic-rospy, ros-melodic-sensor-msgs, ros-melodic-std-msgs
Description: Drive-by-wire interface to the Dataspeed Inc.
 Chrysler Pacifica DBW kit

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-dbw-fca-can//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-dbw-fca-can 1.3.0

=== debian/changelog ===
ros-melodic-dbw-fca-can (1.3.0-1bionic) bionic; urgency=high

  * Bump firmware versions
  * Change unsigned vehicle speed to signed vehicle velocity
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 30 Nov 2022 05:00:00 -0000

ros-melodic-dbw-fca-can (1.2.3-1bionic) bionic; urgency=high

  * Periodically publish DBW enabled status in addition to latched and on change
  * Bump firmware versions
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 13 May 2022 04:00:00 -0000

ros-melodic-dbw-fca-can (1.2.2-1bionic) bionic; urgency=high

  * Bump firmware versions
  * Minor cleanup
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 08 Mar 2022 05:00:00 -0000

ros-melodic-dbw-fca-can (1.2.1-1bionic) bionic; urgency=high

  * Bump firmware versions
  * Add reserved bits
  * Improve printing of license info
  * Add ignition status to ThrottleInfoReport
  * Add user control of alert
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Mon, 20 Sep 2021 04:00:00 -0000

ros-melodic-dbw-fca-can (1.2.0-1bionic) bionic; urgency=high

  * Bump firmware versions
  * C++17 and std::clamp()
  * Remove ROS Kinetic support
  * Populate brake/throttle/steering command values even if enable is false
  * Fix socketcan error frame lock up
  * Contributors: Kevin Hallenbeck, Robert Maupin

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 12 May 2021 04:00:00 -0000

ros-melodic-dbw-fca-can (1.1.3-1bionic) bionic; urgency=high

  * Bump firmware versions
  * License multiple features individually
  * Add option to use socketcan hardware
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 09 Mar 2021 05:00:00 -0000

ros-melodic-dbw-fca-can (1.1.2-1bionic) bionic; urgency=high

  * Bump firmware versions
  * Fix typo in MiscCmd message
  * Update brake type field to match firmware change
  * Add Ford Ranger platform
  * Add reserved bit to prevent warnings
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 14 Jan 2021 05:00:00 -0000

ros-melodic-dbw-fca-can (1.1.1-1bionic) bionic; urgency=high

  * Bump firmware versions
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Mon, 17 Aug 2020 04:00:00 -0000

ros-melodic-dbw-fca-can (1.1.0-1bionic) bionic; urgency=high

  * Add HVAC control and status
  * Contributors: Kevin Hallenbeck, Sun Hwang

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Mon, 10 Aug 2020 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.11-1bionic) bionic; urgency=high

  * Only publish joint states from DbwNode if set to load URDF model
    The joint states messages from DbwNode collide with the joint states published by the Gazebo simulator otherwise.
  * Change names of joints to be different from links
    Gazebo 11 doesn't let joint names and link names be the same, which was allowed in earlier versions
  * Contributors: Kevin Hallenbeck, Micho Radovnikovich

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 05 Aug 2020 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.10-1bionic) bionic; urgency=high

  * Add gear reject enumerations
  * Increase CMake minimum version to 3.0.2 to avoid warning about CMP0048
    http://wiki.ros.org/noetic/Migration#Increase_required_CMake_version_to_avoid_author_warning
  * Remove unused parameter from launch file
  * Add sensor reports for wiper, highbeam, and hazard light
  * Add sensor reports for gyro, accelerometer, GPS, and tire pressure
  * Contributors: Kevin Hallenbeck, Sreedevi Adukkathayar, Sun Hwang

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 09 Jul 2020 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.9-1bionic) bionic; urgency=high

  * Update firmware versions
  * Report NAN for signals that are unavailable/faulted
  * Add door commands
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 14 Feb 2020 05:00:00 -0000

ros-melodic-dbw-fca-can (1.0.8-1bionic) bionic; urgency=high

  * Add launch file argument to switch between Jeep and Pacifica URDF models
  * Contributors: Micho Radovnikovich

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 17 Oct 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.7-1bionic) bionic; urgency=high

  * Added argument to enable/disable CAN message filtering on DBW message range
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 13 Sep 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.6-1bionic) bionic; urgency=high

  * Updated firmware versions
  * Updated website maintenance link
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 13 Aug 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.5-1bionic) bionic; urgency=high

  * Extend licensing to each module
  * Contributors: Kevin Hallenbeck, Sun Hwang

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 24 Jul 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.4-1bionic) bionic; urgency=high

  * Added support for non-hybrid brake report values
  * Added gear number to ThrottleInfoReport
  * Contributors: Kevin Hallenbeck, Sun Hwang

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 11 Jul 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.3-1bionic) bionic; urgency=high

  * Added warnings for unknown and unsupported command types
  * Added FORD_C1 platform
  * Added fuel level report message
  * Added casts to force single precision floating point math
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Fri, 03 May 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.2-1bionic) bionic; urgency=high



 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 14 Mar 2019 04:00:00 -0000

ros-melodic-dbw-fca-can (1.0.1-1bionic) bionic; urgency=high

  * Updated firmware versions


=== debian/control ===
Source: ros-melodic-dbw-fca-can
Section: misc
Priority: optional
Maintainer: Kevin Hallenbeck <khallenbeck@dataspeedinc.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-can-msgs, ros-melodic-catkin, ros-melodic-dataspeed-can-msg-filters, ros-melodic-dbw-fca-msgs, ros-melodic-geometry-msgs, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-roslaunch <!nocheck>, ros-melodic-rospy, ros-melodic-sensor-msgs, ros-melodic-std-msgs
Homepage: http://dataspeedinc.com
Standards-Version: 3.9.2

Package: ros-melodic-dbw-fca-can
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-can-msgs, ros-melodic-dataspeed-can-usb, ros-melodic-dataspeed-ulc-can, ros-melodic-dbw-fca-description, ros-melodic-dbw-fca-msgs, ros-melodic-geometry-msgs, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-roslaunch, ros-melodic-rospy, ros-melodic-sensor-msgs, ros-melodic-socketcan-bridge, ros-melodic-std-msgs
Description: Drive-by-wire interface to the Dataspeed Inc.
 Chrysler Pacifica DBW kit

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
